package com.hzs.bonus.detail.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.hzs.common.domain.member.detail.CuMemberAssess;
import com.hzs.common.domain.member.ext.CuMemberSettleExt;
import com.hzs.bonus.detail.vo.CuMemberAssessVO;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 会员信息-会员考核记录 服务类
 */
public interface ICuMemberAssessService extends IService<CuMemberAssess> {

    /**
     * 每月初，初始化考核数据，根据月底网体数据，先进行奖金计算在进行考核，考核在计算奖金之后
     *
     * @param settleDate 结算日期
     * @param period     结算期间
     */
    void initCuMemberAssessData(String settleDate, int period);

    /**
     * 创建考核月表
     *
     * @param date
     */
    void createCuMemberAssessMonth(String date);

    /**
     * 复购考核每月第一考核调用此方法
     */
    void calculationCuMemberAssess(Date currentDate);

    /**
     * 重算考核 奖金用、每天的重算复购考核用（复购考核、分红考核）,只重算免考的
     *
     * @param currentDate 哪一天进行重新复购考核，拿昨天的值跟现在的值对比
     */
    void retryCalculationAssess(Date currentDate, Boolean flag);

    /**
     * 根据会员主键查询考核结果
     *
     * @param assessTableName       考核表
     * @param period                期间
     * @param assessType            考核类型
     * @param cuMemberSettleExtList 会员列表
     */
    Map<Long, CuMemberAssess> queryCuMemberAssessByMember(String assessTableName, Integer period, Integer assessType, List<CuMemberSettleExt> cuMemberSettleExtList);

    /**
     * 查询会员分红考核结果，只查询出免考或者考核通过的，用于分红
     *
     * @param tableName 表名
     * @param period    期间
     */
    List<CuMemberAssess> queryCuMemberShareAssess(String tableName, Integer period);

    /**
     * 会员-考核明细列表
     **/
    List<CuMemberAssessVO> selectAssessList(CuMemberAssessVO cuMemberAssessVO, List<Integer> orderTypeList);

    /**
     * 查询会员月度考核（查询列表用）
     **/
    List<CuMemberAssessVO> getMemberAssessMonthList(CuMemberAssessVO cuMemberAssessVO);

    /**
     * 查询会员月度考核（查询积分用）
     **/
    List<CuMemberAssessVO> getMemberAssessMonth(CuMemberAssessVO cuMemberAssessVO);

    /**
     * 查询会员订单考核积分
     **/
    CuMemberAssessVO getOrderAssessList(CuMemberAssessVO cuMemberAssessVO);

    List<CuMemberAssessVO> getOrderByAssessList(CuMemberAssessVO cuMemberAssessVO);

    /**
     * 查询满足分红考核的人数，达标人数
     */
    List<CuMemberAssess> queryCuMemberAssTotal(String startDate, Integer pkCountry);

    /**
     * 初始化会员考核数据
     *
     * @param settleDate
     * @param currentSettleTableName
     */
    void initMemberAssess(String settleDate, String currentSettleTableName);

    /**
     * 区域收益考核
     *
     * @param settleDate             结算日期（本月最后一天）
     * @param currentSettleDate      结算日期（本月最后一天）
     * @param currentSettleTableName 今天日结表（本月最后一天）
     */
    void initAreaMemberAssess(String settleDate, Date currentSettleDate, String currentSettleTableName);


}
